> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.prolific.com/llms.txt.
> For full documentation content, see https://docs.prolific.com/llms-full.txt.

# Send a message to multiple participants

POST https://api.prolific.com/api/v1/messages/bulk/
Content-Type: application/json

Send a message to multiple participants.

Reference: https://docs.prolific.com/api-reference/messages/bulk-message-participants

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Prolific API for Data Collectors
  version: 1.0.0
paths:
  /api/v1/messages/bulk/:
    post:
      operationId: bulk-message-participants
      summary: Send a message to multiple participants
      description: Send a message to multiple participants.
      tags:
        - subpackage_messages
      parameters:
        - name: Authorization
          in: header
          description: >-
            The Prolific API uses API token to authenticate requests. You can
            create an API token directly from your settings.


            Your API token does not have an expiry date and carries full
            permission, so be sure to keep them secure.


            If your token is leaked, delete it and create a new one directly in
            the app.


            In your requests add `Authorization` header with the value `Token
            <your token>`.
          required: true
          schema:
            type: string
      responses:
        '204':
          description: The message has been sent
          content:
            application/json:
              schema:
                type: object
                properties: {}
        '400':
          description: Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDetail'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SendBulkMessage'
servers:
  - url: https://api.prolific.com
components:
  schemas:
    SendBulkMessage:
      type: object
      properties:
        ids:
          type: array
          items:
            type: string
          description: A list of participant ID's
        body:
          type: string
          description: Message Body. Text is sanitised for safe storage and display.
        study_id:
          type: string
          description: A study ID
      required:
        - ids
        - body
        - study_id
      title: SendBulkMessage
    ErrorDetailDetail2:
      type: object
      properties:
        any_field:
          type: array
          items:
            type: string
          description: >-
            Name of the field with a validation error and as a value an array
            with the error descriptions
      description: All fields with validation errors
      title: ErrorDetailDetail2
    ErrorDetailDetail:
      oneOf:
        - type: string
        - type: array
          items:
            type: string
        - $ref: '#/components/schemas/ErrorDetailDetail2'
      description: Error detail
      title: ErrorDetailDetail
    ErrorDetail:
      type: object
      properties:
        status:
          type: integer
          description: Status code as in the http standards
        error_code:
          type: integer
          description: Internal error code
        title:
          type: string
          description: Error title
        detail:
          $ref: '#/components/schemas/ErrorDetailDetail'
          description: Error detail
        additional_information:
          type: string
          description: Optional extra information
        traceback:
          type: string
          description: Optional debug information
        interactive:
          type: boolean
      required:
        - status
        - error_code
        - title
        - detail
      title: ErrorDetail
  securitySchemes:
    token:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        The Prolific API uses API token to authenticate requests. You can create
        an API token directly from your settings.


        Your API token does not have an expiry date and carries full permission,
        so be sure to keep them secure.


        If your token is leaked, delete it and create a new one directly in the
        app.


        In your requests add `Authorization` header with the value `Token <your
        token>`.

```

## SDK Code Examples

```python
import requests

url = "https://api.prolific.com/api/v1/messages/bulk/"

payload = {
    "ids": ["619e049f7648a4e1f8f3645b", "619e049f7648a4e1f8f3645c", "619e049f7648a4e1f8f3645d"],
    "body": "Thanks for participating in my study",
    "study_id": "6569ece7ca177d19117b1b95"
}
headers = {
    "Authorization": "Token <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.prolific.com/api/v1/messages/bulk/';
const options = {
  method: 'POST',
  headers: {Authorization: 'Token <token>', 'Content-Type': 'application/json'},
  body: '{"ids":["619e049f7648a4e1f8f3645b","619e049f7648a4e1f8f3645c","619e049f7648a4e1f8f3645d"],"body":"Thanks for participating in my study","study_id":"6569ece7ca177d19117b1b95"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.prolific.com/api/v1/messages/bulk/"

	payload := strings.NewReader("{\n  \"ids\": [\n    \"619e049f7648a4e1f8f3645b\",\n    \"619e049f7648a4e1f8f3645c\",\n    \"619e049f7648a4e1f8f3645d\"\n  ],\n  \"body\": \"Thanks for participating in my study\",\n  \"study_id\": \"6569ece7ca177d19117b1b95\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Token <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.prolific.com/api/v1/messages/bulk/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Token <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"ids\": [\n    \"619e049f7648a4e1f8f3645b\",\n    \"619e049f7648a4e1f8f3645c\",\n    \"619e049f7648a4e1f8f3645d\"\n  ],\n  \"body\": \"Thanks for participating in my study\",\n  \"study_id\": \"6569ece7ca177d19117b1b95\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.prolific.com/api/v1/messages/bulk/")
  .header("Authorization", "Token <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"ids\": [\n    \"619e049f7648a4e1f8f3645b\",\n    \"619e049f7648a4e1f8f3645c\",\n    \"619e049f7648a4e1f8f3645d\"\n  ],\n  \"body\": \"Thanks for participating in my study\",\n  \"study_id\": \"6569ece7ca177d19117b1b95\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.prolific.com/api/v1/messages/bulk/', [
  'body' => '{
  "ids": [
    "619e049f7648a4e1f8f3645b",
    "619e049f7648a4e1f8f3645c",
    "619e049f7648a4e1f8f3645d"
  ],
  "body": "Thanks for participating in my study",
  "study_id": "6569ece7ca177d19117b1b95"
}',
  'headers' => [
    'Authorization' => 'Token <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.prolific.com/api/v1/messages/bulk/");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Token <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"ids\": [\n    \"619e049f7648a4e1f8f3645b\",\n    \"619e049f7648a4e1f8f3645c\",\n    \"619e049f7648a4e1f8f3645d\"\n  ],\n  \"body\": \"Thanks for participating in my study\",\n  \"study_id\": \"6569ece7ca177d19117b1b95\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Token <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "ids": ["619e049f7648a4e1f8f3645b", "619e049f7648a4e1f8f3645c", "619e049f7648a4e1f8f3645d"],
  "body": "Thanks for participating in my study",
  "study_id": "6569ece7ca177d19117b1b95"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.prolific.com/api/v1/messages/bulk/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```